Skip to main content

Breadth-first Search - Hard - Question 1

Breadth-first Search - Hard - Question 1


815. Bus Routes

You are given an array routes representing bus routes where routes[i] is a bus route that the ith bus repeats forever.

For example, if routes[0] = [1, 5, 7], this means that the 0th bus travels in the sequence 1 -> 5 -> 7 -> 1 -> 5 -> 7 -> 1 -> ... forever.

You will start at the bus stop source (You are not on any bus initially), and you want to go to the bus stop target. You can travel between bus stops by buses only.

Return the least number of buses you must take to travel from source to target. Return -1 if it is not possible.

Constraints:

1 <= routes.length <= 500.

1 <= routes[i].length <= 10^5

All the values of routes[i] are unique.

sum(routes[i].length) <= 10^5

0 <= routes[i][j] < 10^6

0 <= source, target < 10^6


Analysis:

One of key steps to this question is to build the connections.

For example, once we start with the source stop, then we know what is the next stops to go. With the connections, we should quickly know what they are (without scanning the raw data).

This connection is usually called a graph.

After having this graph, we can do a regular breadth-first search (bfs) for the shortest distance. And also, to avoid redundant visits, we can use a visit array to record this.


See the code below:

class Solution {
public:
    int numBusesToDestination(vector<vector<int>>& routes, int source, int target) {
        int res = 0, n = routes.size();
        if(source == target) return res;
        unordered_map<int, vector<int>> data;
        for(int i=0; i<n; ++i) {
            for(auto &a : routes[i]) {
                data[a].push_back(i);
            }
        }
        vector<int> hs(n, 0), vt(n, 0);
        for(auto &a : data[target]) hs[a] = 1;
        queue<int> q;
        for(auto &a : data[source]) {
            q.push(a);
            vt[a] = 1;
        }
        while(q.size()) {
            ++res;
            int k = q.size();
            for(int i=0; i<k; ++i) {
                auto t = q.front();
                q.pop();
                if(hs[t]) return res;
                for(auto &b : routes[t]) {
                    for(auto &a : data[b]) {
                        if(!vt[a]) {
                            q.push(a);
                            vt[a] = 1;
                        }
                    }
                }
            }
        }
        return -1;
    }
};


Upper Layer




Comments

Popular posts from this blog

Segment Tree

Segment tree can be viewed as an abstract data structure which using some more space to trade for speed. For example, for a typical question with O(N^2) time complexity, the segment tree method can decrease it to O(N*log(N)).  To make it understandable, let us consider one example. Say we have an integer array of N size, and what we want is to query the maximum with a query range [idx1, idx2], where idx1 is the left indexes, and idx2 is the right indexes inclusive. If we only do this kind of query once, then we just need to scan through the array from idx1 to idx2 once, and record the maximum, done. The time complexity is O(N), which is decent enough in most cases even though it is not the optimal one (for example, with a segment tree built, the time complexity can decrease down to O(log(N))). However, how about we need to query the array N times? If we continue to use the naïve way above, then the time complexity is O(N^2), since for each query we need to scan the query range once...

Bit Manipulation - Example

  Leetcode 136 Single Number Given a non-empty array of integers nums, every element appears twice except for one. Find that single one. You must implement a solution with a linear runtime complexity and use only constant extra space. Constraints: 1 <= nums.length <= 3 * 10^4 -3 * 10^4 <= nums[i] <= 3 * 10^4 Each element in the array appears twice except for one element which appears only once. Analysis: If there is no space limitation, this question can be solved by counting easily. But counting requires additional space. Here we can use xor (^) operation based on some interesting observations:  A^A = 0, here A is any number A^0 = A, here A is any number Since all the number appears twice except one, then all the number appear even numbers will be cancelled out, and only the number appears one time is left, which is what we want. See the code below: class Solution { public: int singleNumber(vector<int>& nums) { int res = 0; for(auto ...

Rolling Hash

Rolling hash is one common trick used to increase efficiency of substring comparisons by compressing (or hashing) a string into a integer. After this step, we can compare two strings directly without comparing each chars. So the efficiency can be increased from O(N) to O(1). So how to implement the rolling hash? First we need to choose a base for the expansion and a modulo to mod. The basic formula is (suppose the window is n, and the rolling direction is from left to right), HashVal = (A1*p^(n-1) + A2*p^(n-2) + ... + An-1*p^1 + An*p^0)%mod where HashVal is the hash value, Ai is the ith element, p is the base, and mod is the modulo. To avoid collision as much as we can, p and modulo usually need to be large prime numbers. One corner case is that the base order in the above formula cannot be reversed. Or to be more clear, if the rolling direction is from left to right in an array, the first element should be in the highest order of the base, or times p^(n-1), and the last element times ...